<?php
/**
 * @copyright    Copyright (C) 2009-2011 ACYBA SAS - All rights reserved.
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingJDownloads extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin =& JPluginHelper::getPlugin('acymailing', 'jdownloads');
			$this->params = new acyParameter($plugin->params);
		}
		$tables = strtolower(implode(",", acymailing_getTableList()));
		$this->newDatabase = strpos($tables, strtolower(acymailing_getPrefix()).'jdownloads_categories') != false;
		if(in_array('catid', array_keys(acymailing_getColumns('#__jdownloads_files')))){
            $this->categoryColumn = 'catid';
            $this->fileIdColumn = 'id';
            $this->fileTitleColumn = 'title';
		}else{
            $this->categoryColumn = 'cat_id';
            $this->fileIdColumn = 'file_id';
            $this->fileTitleColumn = 'file_title';
		}
		$this->acypluginsHelper = acymailing_get('helper.acyplugins');
	}

	function acymailing_getPluginType(){
		if($this->params->get('frontendaccess') == 'none' AND !acymailing_isAdmin()) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'JDownloads';
		$onePlugin->function = 'acymailingjdownloads_show';
		$onePlugin->help = 'plugin-jdownloads';
		return $onePlugin;
	}

	function acymailingjdownloads_show(){
		$config = acymailing_config();
		if(version_compare($config->get('version'), '5.5.0', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}
		
		acymailing_loadLanguageFile('com_jdownloads', JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.jdownloads';

		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.'.$this->fileIdColumn, 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->clickable = acymailing_getUserVar($paramBase.".clickable", 'clickable', '1', 'string');
		$pageInfo->download = acymailing_getUserVar($paramBase.".download", 'download', '1', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '|pict:1', 'string');
		$pageInfo->contenttype = acymailing_getUserVar($paramBase.".contenttype", 'contenttype', 'intro', 'string');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->clickableauto = acymailing_getUserVar($paramBase.".clickableauto", 'clickableauto', '1', 'string');
		$pageInfo->autopict = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->automaxvalue = acymailing_getUserVar($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', 'id', 'string');
		$pageInfo->autocontenttype = acymailing_getUserVar($paramBase.".autocontenttype", 'autocontenttype', 'intro', 'string');
		$pageInfo->downloadauto = acymailing_getUserVar($paramBase.".download", 'download', '1', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->autopict = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->cols = acymailing_getUserVar($paramBase.".cols", 'cols', '1', 'string');

		if($this->newDatabase){
			$searchFields = array('a.'.$this->fileIdColumn, 'a.'.$this->fileTitleColumn, 'b.title', 'c.username', 'a.url_download');
		}else{
			$searchFields = array('a.'.$this->fileIdColumn, 'a.'.$this->fileTitleColumn, 'b.cat_title', 'c.username', 'a.url_download');
		}

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}else{
			$filters[] = "a.published != -2";
		}

		if($this->newDatabase){
			$query = 'SELECT SQL_CALC_FOUND_ROWS a.*, a.'.$this->fileIdColumn.' AS file_id, a.'.$this->fileTitleColumn.' AS file_title,b.*, b.title AS cat_title,c.* FROM `#__jdownloads_files` AS a '.'JOIN `#__jdownloads_categories` AS b ON a.'.$this->categoryColumn.' = b.id '.'LEFT JOIN `#__users` AS c ON a.submitted_by = c.id';
		}else{
			$query = 'SELECT SQL_CALC_FOUND_ROWS a.*,b.*,c.* FROM `#__jdownloads_files` AS a '.'JOIN `#__jdownloads_cats` AS b ON a.'.$this->categoryColumn.' = b.cat_id '.'LEFT JOIN `#__users` AS c ON a.submitted_by = c.id';
		}

		if(!empty($pageInfo->filter_cat)) $filters[] = "a.'.$this->categoryColumn.' = ".$pageInfo->filter_cat;
		if(!empty($filters)) $query .= ' WHERE ('.implode(') AND (', $filters).')';
		if(!empty($pageInfo->filter->order->value)) $query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		if(!empty($pageInfo->search)) $rows = acymailing_search($pageInfo->search, $rows);

		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				var selectedtype = '';
				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += "|type:" + document.adminForm.contenttype[i].value;
					}
				}
				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pict.length; i++){
						if(document.adminForm.pict[i].checked){
							otherinfo += '|pict:' + document.adminForm.pict[i].value;
							if(document.adminForm.pict[i].value == 'resized'){
								document.getElementById('pictsize').style.display = '';
								if(document.adminForm.pictwidth.value) otherinfo += '|maxwidth:' + document.adminForm.pictwidth.value;
								if(document.adminForm.pictheight.value) otherinfo += '|maxheight:' + document.adminForm.pictheight.value;
							}else{
								document.getElementById('pictsize').style.display = 'none';
							}
						}
					}
				}

				for(var i = 0; i < document.adminForm.clickable.length; i++){
					if(document.adminForm.clickable[i].checked && document.adminForm.clickable[i].value == 1){
						otherinfo += '|link';
					}
				}

				for(var i = 0; i < document.adminForm.download.length; i++){
					if(document.adminForm.download[i].checked && document.adminForm.download[i].value == 1){
						otherinfo += "|download";
					}
				}
				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{jdownloads:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat' + catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat' + catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateTagAuto();
			}

			function updateTagAuto(){
				tag = '{autojdownloads:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '|min:' + document.adminForm.min_article.value;
				}

				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '|max:' + document.adminForm.max_article.value;
				}

				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked == true){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag = tag + '|type:' + document.adminForm.contenttypeauto[i].value;
					}
				}

				for(var i = 0; i < document.adminForm.downloadauto.length; i++){
					if(document.adminForm.downloadauto[i].checked && document.adminForm.downloadauto[i].value == 1){
						tag += "|download";
					}
				}

				if(selectedtype != 'title'){
					var tmp = 0;
					for(var i = 0; i < document.adminForm.autopict.length; i++){
						if(document.adminForm.autopict[i].checked){
							tag += '|pict:' + document.adminForm.autopict[i].value;
							if(document.adminForm.autopict[i].value == 'resized'){
								document.getElementById('pictsizeauto').style.display = '';
								if(document.adminForm.pictwidthauto.value) tag += '|maxwidth:' + document.adminForm.pictwidthauto.value;
								if(document.adminForm.pictheightauto.value) tag += '|maxheight:' + document.adminForm.pictheightauto.value;
							}else{
								document.getElementById('pictsizeauto').style.display = 'none';
							}
						}
					}
				}
				for(var i = 0; i < document.adminForm.clickableauto.length; i++){
					if(document.adminForm.clickableauto[i].checked && document.adminForm.clickableauto[i].value == 1){
						tag += "|link";
					}
				}

				if(document.adminForm.cols.value){
					tag += "|cols:" + document.adminForm.cols.value;
				}

				if(document.adminForm.contentorder.value){
					tag += "|order:" + document.adminForm.contentorder.value;
				}

				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){
					tag += document.adminForm.contentfilter.value;
				}

				tag += '}';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = acymailing_selectOption($this->fileIdColumn.",DESC", acymailing_translation('ACY_ID'));
		$ordering[] = acymailing_selectOption("ordering,ASC", acymailing_translation('ACY_ORDERING'));
		$ordering[] = acymailing_selectOption("date_added,DESC", acymailing_translation('CREATED_DATE'));
		$ordering[] = acymailing_selectOption("modified_date,DESC", acymailing_translation('MODIFIED_DATE'));
		$ordering[] = acymailing_selectOption($this->fileTitleColumn.",ASC", acymailing_translation('FIELD_TITLE'));

		$contenttype = array();
		$contenttype[] = acymailing_selectOption("title", acymailing_translation('TITLE_ONLY'));
		$contenttype[] = acymailing_selectOption("intro", acymailing_translation('CATEGORY_VIEW'));
		$contenttype[] = acymailing_selectOption("full", acymailing_translation('DETAILS_VIEW'));

		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		jimport('joomla.html.pane');

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('jdownloads_tab');
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), 'jdownloads_listings');
		?>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td><?php echo acymailing_translation('DISPLAY'); ?></td>
					<td colspan="3"><?php echo acymailing_radio($contenttype, 'contenttype', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
				</tr>
				<tr>
					<td>
						<?php echo acymailing_translation('CLICKABLE_TITLE'); ?>
					</td>
					<td>
						<?php echo acymailing_radio($choice, 'clickable', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->clickable); ?>
					</td>
					<td>
						<?php
						if(!ACYMAILING_J16){
							echo acymailing_translation('JLIST_LINKTEXT_DOWNLOAD_URL');
						}else{
							echo acymailing_translation('COM_JDOWNLOADS_LINKTEXT_DOWNLOAD_URL');
						}
						?>
					</td>
					<td>
						<?php echo acymailing_radio($choice, 'download', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->download); ?>
					</td>
				</tr>
				<!-- ===============================================================================REDIM IMAGE==================================================================================== -->
				<tr>
					<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('DISPLAY_PICTURES'); ?></td>
					<td nowrap="nowrap" colspan="3"><?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
					</td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td width="100%">
						<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
						<button onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php echo $this->_categories($pageInfo->filter_cat); ?>
					</td>
				</tr>
			</table>

			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th/>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.'.$this->fileTitleColumn, $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('ACY_FILES'), 'a.url_download', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.'.$this->fileIdColumn, $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter();
						echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				for($i = 0, $a = count($rows); $i < $a; $i++){
					$row =& $rows[$i];
					?>
					<tr id="content<?php echo $row->file_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->file_id.",'row$k'" ?>);" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							$text = '<b>'.acymailing_translation('JOOMEXT_ALIAS').' : </b>'.$row->file_title;
							$text .= '<br /><b>'.acymailing_translation('ACY_USERNAME', true).' : </b>'.$row->username;
							echo acymailing_tooltip($text, $row->description, '', $row->file_title);
							?>
						</td>
						<td>
							<?php echo $row->url_download; ?>
						</td>
						<td>
							<?php
							if(!empty($row->cat_title)){
								$text = '<b>'.acymailing_translation('TAG_CATEGORIES', true).' : </b>'.$row->cat_title;
								echo acymailing_tooltip($text, $row->cat_title, '', $row->cat_title);
							}
							?>
						</td>
						<td align="center" style="text-align:center">
							<?php echo $row->file_id; ?>
						</td>
					</tr>
					<?php
					$k = 1 - $k;
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel(acymailing_translation('TAG_CATEGORIES'), 'jdownloads_auto');
		?>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td><?php echo acymailing_translation('DISPLAY'); ?></td>
					<td colspan="3"><?php echo acymailing_radio($contenttype, 'contenttypeauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
				</tr>
				<tr>
					<td>
						<?php echo acymailing_translation('CLICKABLE_TITLE'); ?>
					</td>
					<td>
						<?php echo acymailing_radio($choice, 'clickableauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->clickableauto); ?>
					</td>
					<td>
						<?php
						if(!ACYMAILING_J16){
							echo acymailing_translation('JLIST_LINKTEXT_DOWNLOAD_URL');
						}else{
							echo acymailing_translation('COM_JDOWNLOADS_LINKTEXT_DOWNLOAD_URL');
						}
						?>
					</td>
					<td>
						<?php echo acymailing_radio($choice, 'downloadauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->downloadauto); ?>
					</td>
				</tr>
				<tr>
					<td nowrap="nowrap" valign="top">
						<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
					</td>
					<td nowrap="nowrap"><?php echo acymailing_radio($valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict); ?>
						<span id="pictsizeauto" <?php if($pageInfo->autopict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
					x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
				</span>
					</td>
					<td nowrap="nowrap" valign="top"><?php echo acymailing_translation('FIELD_COLUMNS'); ?></td>
					<td nowrap="nowrap" valign="top">
						<?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo acymailing_translation('MAX_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="max_article" size="10" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
					</td>
					<td>
						<?php echo acymailing_translation('ACY_ORDER'); ?>
					</td>
					<td>
						<?php echo acymailing_select($ordering, 'contentorder', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
					</td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td>
							<?php echo acymailing_translation('MIN_ARTICLE'); ?>
						</td>
						<td>
							<input type="text" name="min_article" size="10" value="1" onchange="updateTagAuto();"/>
						</td>
						<td>
							<?php echo acymailing_translation('ACY_FILTER'); ?>
						</td>
						<td>
							<?php $filter = acymailing_get('type.contentfilter');
							$filter->onclick = 'updateTagAuto();';
							echo $filter->display('contentfilter', $pageInfo->contentfilter); ?>
						</td>
					</tr>
				<?php } ?>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table" cellpadding="1" width="100%">
				<?php $k = 0;
				foreach($this->catvalues as $oneCat){
					if(empty($oneCat->value)) continue;
					?>
					<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
						<td class="acytdcheckbox"></td>
						<td>
							<?php
							echo $oneCat->text;
							?>
						</td>
					</tr>
					<?php $k = 1 - $k;
				} ?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		if($this->newDatabase){
			$mosetCats = acymailing_loadObjectList('SELECT *, id AS cat_id, title AS cat_title FROM #__jdownloads_categories WHERE published="1" ORDER BY `id` DESC');
		}else $mosetCats = acymailing_loadObjectList('SELECT * FROM #__jdownloads_cats WHERE published="1" ORDER BY `cat_id` DESC');
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildrens();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	function _handleChildrens($parent_id = 0, $level = 0){
		if(empty($this->cats[$parent_id])) return;
		foreach($this->cats[$parent_id] as $cat){
			//$cat->name = str_repeat($this->separator,$level).$cat->cat_name;
			$this->catvalues[] = acymailing_selectOption($cat->cat_id, str_repeat(" - - ", $level).$cat->cat_title);
			$this->_handleChildrens($cat->cat_id, $level + 1);
		}
	}


	function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$match = '#{jdownloads:(.*)}#Ui';
		$variables = array('subject', 'body', 'altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match, $email->$var, $results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				$content = $this->_replaceContent($allresults, $i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content, true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$results, $i){
		
		acymailing_loadLanguageFile('com_jdownloads', JPATH_SITE);
		$result = '';

		//1 : Transform the tag properly...
		$arguments = explode('|', strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int)$arguments[0];
		for($i = 1, $a = count($arguments); $i < $a; $i++){
			$args = explode(':', $arguments[$i]);
			if(isset($args[1])){
				$tag->{$args[0]} = $args[1];
			}else{
				$tag->{$args[0]} = true;
			}
		}
		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		if($this->newDatabase){
			$query = 'SELECT a.*, a.'.$this->fileIdColumn.' AS file_id, a.'.$this->fileTitleColumn.' AS file_title,b.*,c.* FROM `#__jdownloads_files` AS a '.'JOIN #__jdownloads_categories AS b ON a.'.$this->categoryColumn.' = b.id '.'LEFT JOIN #__users AS c ON a.created_by = c.id '.'WHERE a.'.$this->fileIdColumn.' = "'.intval($tag->id).'" LIMIT 1';
		}else{
			$query = 'SELECT a.*,b.*,c.* FROM `#__jdownloads_files` AS a '.'JOIN #__jdownloads_cats AS b ON a.'.$this->categoryColumn.' = b.cat_id '.'LEFT JOIN #__users AS c ON a.created_by = c.id '.'WHERE '.$this->fileIdColumn.' = "'.intval($tag->id).'" LIMIT 1';
		}
		$article = acymailing_loadObject($query);


		//In case of we could not load the article for any reason...
		if(empty($article)){
			if(acymailing_isAdmin()) acymailing_enqueueMessage('The document "'.$tag->id.'" could not be loaded', 'notice');
			return $result;
		}

		$itemid = $this->params->get('ItemId', "");

		if($this->newDatabase){
			$link = 'index.php?option=com_jdownloads&view=download&id='.$article->file_id.'&catid='.$article->{$this->categoryColumn};
		}else{
			$link = 'index.php?option=com_jdownloads&Itemid=0&view=viewdownload&catid='.$article->{$this->categoryColumn}.'&cid='.$article->file_id;
		}
		if(!empty($itemid)) $link .= '&Itemid='.$itemid;
		$link = acymailing_frontendLink($link);

		if(!empty($tag->autologin)) $link .= (strpos($link, '?') ? '&' : '?').'user={usertag:username|urlencode}&passw={usertag:password|urlencode}';


		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';

		$resultTitle = '';
		if(empty($tag->notitle)){
			if(!empty($article->file_pic)){
				$resultTitle .= '<img src="images/jdownloads/fileimages/'.$article->file_pic.'" style="float:left;margin:5px;" />';
			}
			if(!empty($tag->link)){
				$resultTitle .= '<a href="'.$link.'" ';
				if($tag->type != "title") $resultTitle .= 'style="text-decoration:none" name="jdownloads-'.$article->file_id.'" ';
				$resultTitle .= 'target="_blank" >'.$styleTitle.$article->file_title.$styleTitleEnd.'</a>';
			}else{
				$resultTitle .= $styleTitle.$article->file_title.$styleTitleEnd;
			}
		}

		if(!empty($tag->download)){
			if(!ACYMAILING_J16){
				$download = '<br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.acymailing_translation('JLIST_LINKTEXT_DOWNLOAD_URL').'</span></a>';
			}else{
				$download = '<br /><a style="text-decoration:none;" target="_blank" href="'.$link.'"><span class="acymailing_readmore">'.acymailing_translation('COM_JDOWNLOADS_LINKTEXT_DOWNLOAD_URL').'</span></a>';
			}
		}else{
			$download = '';
		}

		if($tag->type != "title"){
			if($tag->type == "intro"){
				if(!empty($article->thumbnail)){
					$result .= '<img src="images/jdownloads/screenshots/'.$article->thumbnail.'" style="float:right;margin-left:5px;"/>';
				}
				if(!empty($article->description)){
					$result .= $article->description;
				}
			}else{
				$result .= '<div>';

				if(!empty($article->thumbnail)){
					$result .= '<img src="images/jdownloads/screenshots/'.$article->thumbnail.'" style="float:right;margin-left:5px;"/>';
				}
				if(!empty($article->description_long)){
					$result .= $article->description_long;
				}

				$result .= '</div><br /><table  width="100%" border="0" cellpadding="0" cellspacing="0">';
				if(!empty($article->url_download)){
					$result .= '<tr><td class="fieldname" >'.acymailing_translation('ACY_FILES').' :</td><td class="fieldvalue" >'.$article->url_download.'</td>';
					$result .= '<td class="fieldname" >'.acymailing_translation('FIELD_SIZE').' :</td><td class="fieldvalue" >'.$article->size.'</td></tr>';
				}
				if(!empty($article->created_by) && !empty($article->date_added)){
					$result .= '<tr><td class="fieldname" >'.acymailing_translation('ACY_CREATED').' :</td><td class="fieldvalue" >'.$article->created_by.'</td>';
					$result .= '<td class="fieldname" >'.acymailing_translation('ACY_PUBLISHED').' :</td><td class="fieldvalue" >'.acymailing_getDate(acymailing_getTime($article->date_added), acymailing_translation('DATE_FORMAT_LC')).'</td></tr>';
				}

				if(false && !empty($article->modified_by)){
					$result .= '<tr><td class="fieldname" >'.acymailing_translation('ACTION_MODIFIED').' '.acymailing_translation('JLIST_BACKEND_FILESEDIT_MODIFIED_BY').' :</td><td class="fieldvalue" >'.$article->modified_by.'</td>';
					$result .= '<td class="fieldname" >'.acymailing_translation('MODIFIED_DATE').' :</td><td class="fieldvalue" >'.acymailing_getDate(acymailing_getTime($article->modified_date), acymailing_translation('DATE_FORMAT_LC')).'</td></tr>';
				}
				$result .= "</table>";
			}

			$result = $resultTitle.$result.$download;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result.$download;
		}


		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'jdownloads.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'jdownloads.php');
			$result = ob_get_clean();
		}

		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = $acypluginsHelper->removeJS($result);

		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight', 150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth', 150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif(acymailing_isAdmin()){
					acymailing_enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}

		return $result;
	}

	private function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);
		if(empty($this->tags)) return;
		$this->acypluginsHelper->replaceTags($email, $this->tags, true);
	}

	function acymailing_generateautonews(&$email){
		$time = time();

		//load the tags
		$tags = $this->acypluginsHelper->extractTags($email, 'autojdownloads');
		$return = new stdClass();
		$return->status = true;
		$return->message = '';
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])) continue;
			$allcats = explode('-', $parameter->id);
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = intval($oneCat);
			}

			$query = 'SELECT '.$this->fileIdColumn.' FROM #__jdownloads_files';
			$where = array();
			if(!empty($selectedArea)) $where[] = '`'.$this->categoryColumn.'` IN ('.implode(',', $selectedArea).')';

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				if(ACYMAILING_J16){
					$date = acymailing_getDate($email->params['lastgenerateddate'], "Y-m-d H:i:s");
				}else{
					$offset = acymailing_getCMSConfig('offset');
					$datenow =& JFactory::getDate($email->params['lastgenerateddate']);
					$datenow->setOffset($offset);
					$date = $datenow->toFormat("%Y-%m-%d %H:%M:%S");
				}
				$condition = '`date_added` >\''.$date.'\'';
				if($parameter->filter == 'modify') $condition .= ' OR `modified_date` > \''.$date.'\'';
				$where[] = $condition;
			}

			$where[] = "published = 1";

			if(!empty($parameter->mindate)){
				$where[] = 'date_added > '.acymailing_escapeDB($parameter->mindate);
			}

			$query .= ' WHERE ('.implode(') AND (', $where).')';
			if(!empty($parameter->order)){
				$ordering = explode(',', $parameter->order);
				$query .= ' ORDER BY `'.acymailing_secureField($ordering[0]).'` '.acymailing_secureField($ordering[1]);
			}
			if(!empty($parameter->max)){
				$query .= ' LIMIT '.(int)$parameter->max;
			}else $query .= ' LIMIT 20';
			//We add a limit for the preview otherwise we could break everything

			$allArticles = acymailing_loadResultArray($query);

			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough JDownloads content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autojdownloads.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autojdownloads.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					$stringTag .= '<table cellspacing="0" cellpadding="0" border="0">';
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'jdownloads:'.$oneArticleId;
						if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->download)) $args[] = 'download';
						if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
						if(!empty($parameter->notitle)) $args[] = 'notitle';
						if(!empty($parameter->created)) $args[] = 'created';
						if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->autologin)) $args[] = 'autologin';
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $this->acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}

		return $return;
	}

	function onAcyDisplayFilters(&$type){
		if(!in_array(acymailing_getPrefix().'jdownloads_groups', acymailing_getTableList())) return '';
		$type['jdownloads_groups'] = 'Jdownloads Groups';

		$groups = acymailing_loadObjectList("SELECT `id`,`groups_name` FROM `#__jdownloads_groups` ORDER BY `groups_name` ASC");
		$groupsin = acymailing_get('type.operatorsin');

		$return = '<div id="filter__num__jdownloads_groups">'.$groupsin->display("filter[__num__][jdownloads_groups][type]");
		$return .= ' '.acymailing_select($groups, "filter[__num__][jdownloads_groups][group]", 'class="inputbox" size="1"', 'id', 'groups_name').'</div>';

		return $return;
	}

	function onAcyProcessFilter_jdownloads_groups(&$query, $filter, $num){
		//We get the e-mail of the users which belong to this group, it's much easier that way
		$allIds = acymailing_loadResult('SELECT groups_members FROM `#__jdownloads_groups` WHERE `id` = '.intval($filter['group']));
		if(empty($allIds)) $allIds = '-1';
		$operator = ($filter['type'] == 'IN') ? 'IN' : "NOT IN";
		$query->where[] = "sub.userid $operator (".$allIds.")";
	}
}//endclass
