<?php
/**
 * @copyright    Copyright (C) 2009-2018 ACYBA SAS - All rights reserved..
 * @license        GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingRemository extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'remository');
			$this->params = new acyParameter($plugin->params);
		}
	}

	function acymailing_getPluginType(){
		if($this->params->get('frontendaccess') == 'none' AND !acymailing_isAdmin()) return;
		$onePlugin = new stdClass();
		$onePlugin->name = 'Remository';
		$onePlugin->function = 'acymailingremository_show';
		$onePlugin->help = 'plugin-remository';
		return $onePlugin;
	}

	function acymailingremository_show(){
		$config = acymailing_config();

		//We will need the latest developped functions
		if(version_compare($config->get('version'), '5.2.0', '<')){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work', 'error');
			return;
		}

		
		acymailing_loadLanguageFile('com_remository', JPATH_SITE);

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.remository';

		$pageInfo->filter->order->value = acymailing_getUserVar($paramBase.".filter_order", 'filter_order', 'a.id', 'cmd');
		$pageInfo->filter->order->dir = acymailing_getUserVar($paramBase.".filter_order_Dir", 'filter_order_Dir', 'desc', 'word');
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = acymailing_getUserVar($paramBase.".search", 'search', '', 'string');
		$pageInfo->search = strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = acymailing_getUserVar($paramBase.".filter_cat", 'filter_cat', '', 'int');
		$pageInfo->titlelink = acymailing_getUserVar($paramBase.".titlelink", 'titlelink', '1', 'string');
		$pageInfo->download = acymailing_getUserVar($paramBase.".download", 'download', '0', 'string');
		$pageInfo->cols = acymailing_getUserVar($paramBase.".cols", 'cols', '1', 'string');
		$pageInfo->pictheight = acymailing_getUserVar($paramBase.".pictheight", 'pictheight', '150', 'string');
		$pageInfo->pictwidth = acymailing_getUserVar($paramBase.".pictwidth", 'pictwidth', '150', 'string');
		$pageInfo->pict = acymailing_getUserVar($paramBase.".pict", 'pict', '1', 'string');
		$pageInfo->pictauto = acymailing_getUserVar($paramBase.".autopict", 'autopict', '1', 'string');
		$pageInfo->contenttype = acymailing_getUserVar($paramBase.".contenttype", 'contenttype', 'intro', 'string');
		$pageInfo->limit->value = acymailing_getUserVar($paramBase.'.list_limit', 'limit', acymailing_getCMSConfig('list_limit'), 'int');
		$pageInfo->limit->start = acymailing_getUserVar($paramBase.'.limitstart', 'limitstart', 0, 'int');
		$pageInfo->autotitlelink = acymailing_getUserVar($paramBase.".autotitlelink", 'autotitlelink', '1', 'string');
		$pageInfo->automaxvalue = acymailing_getUserVar($paramBase.".max", 'max', '20', 'int');
		$pageInfo->contentfilter = acymailing_getUserVar($paramBase.".contentfilter", 'contentfilter', 'created', 'string');
		$pageInfo->contentorder = acymailing_getUserVar($paramBase.".contentorder", 'contentorder', 'id,DESC', 'string');
		$pageInfo->autocontenttype = acymailing_getUserVar($paramBase.".autocontenttype", 'autocontenttype', 'intro', 'string');
		$pageInfo->downloadauto = acymailing_getUserVar($paramBase.".download", 'download', '0', 'string');

		$searchFields = array('a.id', 'a.filetitle', 'b.name', 'c.username', 'a.realname');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search, true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ", $searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart', 'all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}else{
			$filters[] = "a.published != -2";
		}

		$query = 'SELECT a.*,b.*,c.*,a.id AS file_id,b.name AS cat_name FROM `#__downloads_files` AS a '.'JOIN `#__downloads_containers` AS b ON a.containerid = b.id '.'LEFT JOIN `#__users` AS c ON a.submittedby = c.id';

		if(!empty($pageInfo->filter_cat)) $filters[] = "a.containerid = ".$pageInfo->filter_cat;

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (', $filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$rows = acymailing_loadObjectList($query, '', $pageInfo->limit->start, $pageInfo->limit->value);

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search, $rows);
		}

		$pageInfo->elements->total = acymailing_loadResult('SELECT FOUND_ROWS()');
		$pageInfo->elements->page = count($rows);

		$pagination = new acyPagination($pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value);

		$type = acymailing_getVar('string', 'type');

		?>
		<script language="javascript" type="text/javascript">
			<!--
			var selectedContents = new Array();
			function applyContent(contentid, rowClass){
				var tmp = selectedContents.indexOf(contentid)
				if(tmp != -1){
					window.document.getElementById('content' + contentid).className = rowClass;
					delete selectedContents[tmp];
				}else{
					window.document.getElementById('content' + contentid).className = 'selectedrow';
					selectedContents.push(contentid);
				}
				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';

				for(var i = 0; i < document.adminForm.contenttype.length; i++){
					if(document.adminForm.contenttype[i].checked){
						selectedtype = document.adminForm.contenttype[i].value;
						otherinfo += '| type:' + document.adminForm.contenttype[i].value;
					}
				}

				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.pict.length; i++){
						if(document.adminForm.pict[i].checked){
							if(document.adminForm.pict[i].value != '1'){
								otherinfo += '| pict:' + document.adminForm.pict[i].value;
							}

							if(document.adminForm.pict[i].value == 'resized'){
								document.getElementById('pictsize').style.display = '';
								if(document.adminForm.pictwidth.value) otherinfo += '| maxwidth:' + document.adminForm.pictwidth.value;
								if(document.adminForm.pictheight.value) otherinfo += '| maxheight:' + document.adminForm.pictheight.value;
							}else{
								document.getElementById('pictsize').style.display = 'none';
							}
						}
					}
				}

				if(document.adminForm.wrap.value && document.adminForm.wrap.value != 0 && !isNaN(document.adminForm.wrap.value)){
					otherinfo += "| wrap:" + document.adminForm.wrap.value;
				}

				for(var i = 0; i < document.adminForm.titlelink.length; i++){
					if(document.adminForm.titlelink[i].checked && document.adminForm.titlelink[i].value == '1'){
						otherinfo += '| link';
					}
				}

				for(var i = 0; i < document.adminForm.download.length; i++){
					if(document.adminForm.download[i].checked && document.adminForm.download[i].value == '1'){
						otherinfo += '| download';
					}
				}

				for(var i in selectedContents){
					if(selectedContents[i] && !isNaN(i)){
						tag = tag + '{remository:' + selectedContents[i] + otherinfo + '}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid, rowClass){
				if(catid == 'all'){
					if(window.document.getElementById('cat' + catid).className == 'selectedrow'){
						window.document.getElementById('catall').className = rowClass;
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						for(key in selectedCat){
							if(!isNaN(key)){
								window.document.getElementById('cat' + key).className = rowClass;
								delete selectedCat[key];
							}
						}
					}
				}else{
					window.document.getElementById('catall').className = 'row0';
					if(selectedCat[catid]){
						window.document.getElementById('cat' + catid).className = rowClass;
						delete selectedCat[catid];
					}else{
						window.document.getElementById('cat' + catid).className = 'selectedrow';
						selectedCat[catid] = 'selectedone';
					}
				}
				updateTagAuto();
			}

			function updateTagAuto(){
				tag = '{autoremository:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat + '-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value != 0){
					tag += '| min:' + document.adminForm.min_article.value;
				}

				if(document.adminForm.max_article.value && document.adminForm.max_article.value != 0){
					tag += '| max:' + document.adminForm.max_article.value;
				}

				for(var i = 0; i < document.adminForm.contenttypeauto.length; i++){
					if(document.adminForm.contenttypeauto[i].checked){
						selectedtype = document.adminForm.contenttypeauto[i].value;
						tag += '| type:' + document.adminForm.contenttypeauto[i].value;
					}
				}

				for(var i = 0; i < document.adminForm.downloadauto.length; i++){
					if(document.adminForm.downloadauto[i].checked && document.adminForm.downloadauto[i].value == '1'){
						tag += '| download';
					}
				}

				if(selectedtype != 'title'){
					for(var i = 0; i < document.adminForm.autopict.length; i++){
						if(document.adminForm.autopict[i].checked){
							if(document.adminForm.autopict[i].value != '1'){
								tag += '| pict:' + document.adminForm.autopict[i].value;
							}

							if(document.adminForm.autopict[i].value == 'resized'){
								document.getElementById('pictsizeauto').style.display = '';
								if(document.adminForm.pictwidthauto.value) tag += '| maxwidth:' + document.adminForm.pictwidthauto.value;
								if(document.adminForm.pictheightauto.value) tag += '| maxheight:' + document.adminForm.pictheightauto.value;
							}else{
								document.getElementById('pictsizeauto').style.display = 'none';
							}
						}
					}
				}

				if(document.adminForm.wrapauto.value && document.adminForm.wrapauto.value != 0 && !isNaN(document.adminForm.wrapauto.value)){
					tag += "| wrap:" + document.adminForm.wrapauto.value;
				}

				for(var i = 0; i < document.adminForm.autotitlelink.length; i++){
					if(document.adminForm.autotitlelink[i].checked && document.adminForm.autotitlelink[i].value == '1'){
						tag += '| link';
					}
				}

				if(document.adminForm.cols.value){
					tag += "| cols:" + document.adminForm.cols.value;
				}

				if(document.adminForm.contentorder.value){
					tag += '| order:' + document.adminForm.contentorder.value;
				}

				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value != '0'){
					tag += '| filter:' + document.adminForm.contentfilter.value;
				}

				tag += '}';

				setTag(tag);
			}
			//-->
		</script>
		<?php
		$valImages = array();
		$valImages[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$valImages[] = acymailing_selectOption("resized", acymailing_translation('RESIZED'));
		$valImages[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = acymailing_selectOption("id,DESC", acymailing_translation('ACY_ID'));
		$ordering[] = acymailing_selectOption("submitdate,DESC", acymailing_translation('CREATED_DATE'));
		$ordering[] = acymailing_selectOption("filetitle,ASC", acymailing_translation('FIELD_TITLE'));
		$ordering[] = acymailing_selectOption("rand", acymailing_translation('ACY_RANDOM'));

		$contenttype = array();
		$contenttype[] = acymailing_selectOption("title", acymailing_translation('TITLE_ONLY'));
		$contenttype[] = acymailing_selectOption("intro", acymailing_translation('CATEGORY_VIEW'));
		$contenttype[] = acymailing_selectOption("full", acymailing_translation('DETAILS_VIEW'));

		// yes/no for the options
		$choice = array();
		$choice[] = acymailing_selectOption("1", acymailing_translation('JOOMEXT_YES'));
		$choice[] = acymailing_selectOption("0", acymailing_translation('JOOMEXT_NO'));

		$contentfilter = array();
		$contentfilter[] = acymailing_selectOption("0", acymailing_translation('ACY_ALL'));
		$contentfilter[] = acymailing_selectOption("created", acymailing_translation('ONLY_NEW_CREATED'));
		$contentfilter[] = acymailing_selectOption("modified", acymailing_translation('ONLY_NEW_MODIFIED'));

		$column = array();
		for($i = 1; $i < 11; $i++){
			$column[] = acymailing_selectOption("$i", $i);
		}

		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane('remository_tab');
		echo $tabs->startPanel(acymailing_translation('TAG_ELEMENTS'), 'remository_listings');
		?>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td><?php echo acymailing_translation('DISPLAY'); ?></td>
					<td colspan="3"><?php echo acymailing_radio($contenttype, 'contenttype', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'titlelink', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->titlelink); ?></td>
					<td>
						<?php echo acymailing_translation('ACY_DOWNLOAD'); ?>
					</td>
					<td>
						<?php echo acymailing_radio($choice, 'download', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->download); ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
					</td>
					<td nowrap="nowrap"><?php echo acymailing_radio($valImages, 'pict', 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->pict); ?>
						<span id="pictsize" <?php if($pageInfo->pict != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidth" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheight" type="text" onchange="updateTag();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
					<td nowrap="nowrap" colspan="2" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrap" style="width:50px" value="0" onchange="updateTag();"/>'); ?></td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table_options">
				<tr>
					<td width="100%">
						<input placeholder="<?php echo acymailing_translation('ACY_SEARCH'); ?>" type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search; ?>" class="text_area" onchange="document.adminForm.submit();"/>
						<button class="acymailing_button_grey" onclick="this.form.submit();"><?php echo acymailing_translation('JOOMEXT_GO'); ?></button>
						<button class="acymailing_button_grey" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo acymailing_translation('JOOMEXT_RESET'); ?></button>
					</td>
					<td nowrap="nowrap">
						<?php echo $this->_categories($pageInfo->filter_cat); ?>
					</td>
				</tr>
			</table>

			<table class="acymailing_table" cellpadding="1" width="100%">
				<thead>
				<tr>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('FIELD_TITLE'), 'a.filetitle', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('ACY_FILES'), 'a.realname', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title">
						<?php echo acymailing_gridSort(acymailing_translation('TAG_CATEGORIES'), 'b.name', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
					<th class="title titleid">
						<?php echo acymailing_gridSort(acymailing_translation('ACY_ID'), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value); ?>
					</th>
				</tr>
				</thead>
				<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
				</tfoot>
				<tbody>
				<?php
				$k = 0;
				for($i = 0, $a = count($rows); $i < $a; $i++){
					$row =& $rows[$i];
					?>
					<tr id="content<?php echo $row->file_id; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->file_id.",'row$k'" ?>);" style="cursor:pointer;">
						<td>
							<?php
							$text = '<b>'.acymailing_translation('JOOMEXT_ALIAS').' : </b>'.$row->filetitle;
							$text .= '<br /><b>'.acymailing_translation('ACY_USERNAME', true).' : </b>'.$row->username;
							echo acymailing_tooltip($text, $row->subtitle, '', $row->filetitle);
							?>
						</td>
						<td>
							<?php echo $row->realname; ?>
						</td>
						<td>
							<?php
							if(!empty($row->cat_name)){
								$text = '<b>'.acymailing_translation('TAG_CATEGORIES', true).' : </b>'.$row->cat_name;
								echo acymailing_tooltip($text, $row->cat_name, '', $row->cat_name);
							}
							?>
						</td>
						<td align="center" style="text-align:center">
							<?php echo $row->file_id; ?>
						</td>
					</tr>
					<?php
					$k = 1 - $k;
				}
				?>
				</tbody>
			</table>
		</div>
		<input type="hidden" name="boxchecked" value="0"/>
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>"/>
		<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel(acymailing_translation('TAG_CATEGORIES'), 'remository_auto');
		?>
		<div class="onelineblockoptions">
			<table width="100%" class="acymailing_table">
				<tr>
					<td><?php echo acymailing_translation('DISPLAY'); ?></td>
					<td colspan="3"><?php echo acymailing_radio($contenttype, 'contenttypeauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
				</tr>
				<tr>
					<td nowrap="nowrap"><?php echo acymailing_translation('CLICKABLE_TITLE'); ?></td>
					<td nowrap="nowrap"><?php echo acymailing_radio($choice, 'autotitlelink', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autotitlelink); ?></td>
					<td>
						<?php echo acymailing_translation('ACY_DOWNLOAD'); ?>
					</td>
					<td>
						<?php echo acymailing_radio($choice, 'downloadauto', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->downloadauto); ?>
					</td>
				</tr>
				<tr>
					<td>
						<?php echo acymailing_translation('DISPLAY_PICTURES'); ?>
					</td>
					<td nowrap="nowrap"><?php echo acymailing_radio($valImages, 'autopict', 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->pictauto); ?>
						<span id="pictsizeauto" <?php if($pageInfo->pictauto != 'resized') echo 'style="display:none;"'; ?> ><br/>
							<?php echo acymailing_translation('CAPTCHA_WIDTH') ?>
							<input name="pictwidthauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictwidth; ?>" style="width:30px;"/>
						x <?php echo acymailing_translation('CAPTCHA_HEIGHT') ?>
							<input name="pictheightauto" type="text" onchange="updateTagAuto();" value="<?php echo $pageInfo->pictheight; ?>" style="width:30px;"/>
					</span>
					</td>
					<td nowrap="nowrap" colspan="2" valign="top"><?php echo acymailing_translation_sprintf('TRUNCATE_AFTER', '<input type="text" name="wrapauto" style="width:50px" value="0" onchange="updateTagAuto();"/>'); ?></td>
				</tr>
				<tr>
					<td>
						<?php echo acymailing_translation('MAX_ARTICLE'); ?>
					</td>
					<td>
						<input type="text" name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
					</td>
					<td>
						<?php echo acymailing_translation('ACY_ORDER'); ?>
					</td>
					<td>
						<?php echo acymailing_select($ordering, 'contentorder', 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
					</td>
				</tr>
				<?php if($type == 'autonews'){ ?>
					<tr>
						<td>
							<?php echo acymailing_translation('MIN_ARTICLE'); ?>
						</td>
						<td>
							<input type="text" name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
						</td>
						<td nowrap="nowrap">
							<?php echo acymailing_translation('JOOMEXT_FILTER'); ?>
						</td>
						<td nowrap="nowrap">
							<?php echo acymailing_select($contentfilter, 'contentfilter', 'style="width:200px;" size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentfilter); ?>
						</td>
					</tr>
				<?php } ?>
				<tr>
					<td>
						<?php echo acymailing_translation('FIELD_COLUMNS'); ?>
					</td>
					<td nowrap="nowrap" colspan="3">
						<?php echo acymailing_select($column, 'cols', 'size="1" onchange="updateTagAuto();" style="width:100px;"', 'value', 'text', $pageInfo->cols); ?>
					</td>
				</tr>
			</table>
		</div>
		<div class="onelineblockoptions">
			<table class="acymailing_table" cellpadding="1" width="100%">
				<?php
				$k = 0;
				?>
				<tr id="catall" class="<?php echo "row$k"; ?>" onclick="applyAuto('all','<?php echo "row$k" ?>');" style="cursor:pointer;">
					<td class="acytdcheckbox"></td>
					<td>
						<?php
						echo acymailing_translation('ACY_ALL');
						?>
					</td>
				</tr>
				<?php
				if(!empty($this->catvalues)){
					foreach($this->catvalues as $oneCat){
						if(empty($oneCat->value)) continue;
						?>
						<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
							<td class="acytdcheckbox"></td>
							<td>
								<?php
								echo $oneCat->text;
								?>
							</td>
						</tr>
						<?php
						$k = 1 - $k;
					}
				}
				?>
			</table>
		</div>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	}

	function _categories($filter_cat){
		//select all cats
		$mosetCats = acymailing_loadObjectList('SELECT * FROM #__downloads_containers WHERE published="1" ORDER BY `id` DESC');
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parentid][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = acymailing_selectOption(0, acymailing_translation('ACY_ALL'));
		$this->_handleChildrens();
		return acymailing_select($this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int)$filter_cat);
	}

	function _handleChildrens($parentid = 0, $level = 0){
		if(!empty($this->cats[$parentid])){
			foreach($this->cats[$parentid] as $cat){
				//$cat->name = str_repeat($this->separator,$level).$cat->cat_name;
				$this->catvalues[] = acymailing_selectOption($cat->id, str_repeat(" - - ", $level).$cat->name);
				$this->_handleChildrens($cat->id, $level + 1);
			}
		}
	}


	function acymailing_replacetags(&$email, $send = true){
		$this->_replaceAuto($email);
		$this->_replaceOne($email);
	}

	function _replaceOne(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		//load the tags
		$tags = $acypluginsHelper->extractTags($email, 'remository');
		if(empty($tags)){
			return;
		}

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($tags as $i => $params){
			if(isset($htmlreplace[$i])) continue;
			$content = $this->_replaceContent($tags[$i]);
			$htmlreplace[$i] = $content;
			$textreplace[$i] = $this->mailerHelper->textVersion($content, true);
			$subjectreplace[$i] = strip_tags($content);
		}
		$email->body = str_replace(array_keys($htmlreplace), $htmlreplace, $email->body);
		$email->altbody = str_replace(array_keys($textreplace), $textreplace, $email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace), $subjectreplace, $email->subject);
	}

	function _replaceContent(&$tag){
		$acypluginsHelper = acymailing_get('helper.acyplugins');
		$result = '';
		include_once(ACYMAILING_ROOT.'components'.DS.'com_remository'.DS.'language'.DS.'english.php');
		include_once(ACYMAILING_ROOT.'components'.DS.'com_remository'.DS.'remository.interface.php');
		include_once(ACYMAILING_ROOT.'components'.DS.'com_remository'.DS.'remository.class.php');
		$customobj = new remositoryCustomizer();
		$values = $customobj->getCustomSpec();

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT a.*,b.*,c.*,a.id AS file_id,b.name AS cat_name,a.icon as file_icon,b.id as cat_id, a.description AS filedesc FROM `#__downloads_files` AS a '.'JOIN `#__downloads_containers` AS b ON a.containerid = b.id '.'LEFT JOIN `#__users` AS c ON a.submittedby = c.id '.'WHERE a.id = "'.intval($tag->id).'" LIMIT 1';
		$article = acymailing_loadObject($query);

		$varFields = array();
		foreach($article as $fieldName => $oneField){
			$varFields['{'.$fieldName.'}'] = $oneField;
		}

		//In case of we could not load the article for any reason...
		if(empty($article)){
			if(acymailing_isAdmin()){
				acymailing_enqueueMessage('The document "'.$tag->id.'" could not be loaded', 'notice');
			}
			return $result;
		}

		$itemid = $this->params->get('ItemId', 0);

		$link = 'index.php?option=com_remository&Itemid='.$itemid.'&func=fileinfo&id='.$article->file_id;
		$linkdownload = 'index.php?option=com_remository&Itemid='.$itemid.'&func=startdown&id='.$article->file_id;
		$link = acymailing_frontendLink($link);
		$linkdownload = acymailing_frontendLink($linkdownload);

		$varFields['{link}'] = $link;
		$varFields['{linkdownload}'] = $linkdownload;

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';
		$resultTitle = '';

		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				if(!empty($article->file_icon)){
					$resultTitle .= '<img src="components/com_remository/images/file_icons/'.$article->file_icon.'" style="float:left;margin:5px;" />';
				}
				$resultTitle .= '<a href="'.$link.'" ';
				if($tag->type != "title") $resultTitle .= 'style="text-decoration:none" name="remository-'.$article->file_id.'" ';
				$resultTitle .= 'target="_blank" >'.$article->filetitle.'</a>';
			}else{
				$resultTitle = '<img src="components/com_remository/images/file_icons/'.$article->file_icon.'" style="margin:5px;float:left;" />';
				$resultTitle .= $article->filetitle;
			}
			$resultTitle = $styleTitle.$resultTitle.$styleTitleEnd;
		}

		if(!empty($tag->download)){
			$download = '<a style="text-decoration:none;" target="_blank" href="'.$linkdownload.'"><span class="acymailing_readmore">'.acymailing_translation('ACY_DOWNLOAD').'</span></a>';
		}else{
			$download = '';
		}
		//////////////////////////////////////////////////////// Views /////////////////////////////////////////////////////////////////
		if(!empty($article->username)){
			if($values['A'][1] == 1){
				$intro[] = '<td>'.acymailing_translation('ACY_CREATED').' :</td><td> '.$article->username.'</td>';
			}
			if($values['D'][1] == 1){
				$full[] = '<td>'.acymailing_translation('ACY_CREATED').' :</td><td> '.$article->username.'</td>';
			}
		}

		if(!empty($article->submitdate)){
			if($values['A'][2] == 1){
				$intro[] = '<td>'.acymailing_translation('ACY_PUBLISHED').' :</td><td> '.$article->submitdate.'</td>';
			}
			if($values['D'][2] == 1){
				$full[] = '<td>'.acymailing_translation('ACY_PUBLISHED').' :</td><td> '.$article->submitdate.'</td>';
			}
		}

		if(!empty($article->realname)){
			if($values['A'][3] == 1){
				$intro[] = '<td>'.acymailing_translation('ACY_FILES').' :</td><td> '.$article->realname.'</td>';
				$intro[] = '<td>'.acymailing_translation('FIELD_SIZE').' :</td><td> '.$article->filesize.'</td>';
			}
			if($values['D'][3] == 1){
				$full[] = '<td>'.acymailing_translation('ACY_FILES').' :</td><td> '.$article->realname.'</td>';
				$full[] = '<td>'.acymailing_translation('FIELD_SIZE').' :</td><td> '.$article->filesize.'</td>';
			}
		}

		if(!empty($article->fileversion)){
			if($values['A'][7] == 1){
				$intro[] = '<td>'.acymailing_translation('RECEIVED_VERSION').' :</td><td> '.$article->fileversion.'</td>';
			}
			if($values['D'][7] == 1){
				$full[] = '<td>'.acymailing_translation('RECEIVED_VERSION').' :</td><td> '.$article->fileversion.'</td>';
			}
		}

		if(!empty($article->fileauthor)){
			if($values['A'][8] == 1){
				$intro[] = '<td>'.acymailing_translation('AUTHOR_NAME').' :</td><td> '.$article->fileauthor.'</td>';
			}
			if($values['D'][8] == 1){
				$full[] = '<td>'.acymailing_translation('AUTHOR_NAME').' :</td><td> '.$article->fileauthor.'</td>';
			}
		}

		if(!empty($article->filehomepage)){
			if($values['A'][9] == 1){
				$intro[] = '<td>'.acymailing_translation('REDIRECT_LINK').' :</td><td> '.$article->filehomepage.'</td>';
			}
			if($values['D'][9] == 1){
				$full[] = '<td>'.acymailing_translation('REDIRECT_LINK').' :</td><td> '.$article->filehomepage.'</td>';
			}
		}

		if(!empty($article->filedate)){
			if($values['A'][10] == 1){
				$intro[] = '<td>'.acymailing_translation('CREATED_DATE').' :</td><td> '.$article->filedate.'</td>';
			}
			if($values['D'][10] == 1){
				$full[] = '<td>'.acymailing_translation('CREATED_DATE').' :</td><td> '.$article->filedate.'</td>';
			}
		}

		//////////////////////////////////////////////////////// /Views ////////////////////////////////////////////////////////////////
		if($tag->type != "title"){
			if($tag->type == "intro"){
				if(!empty($article->subtitle)){
					$result .= $article->subtitle.'<br /><br />';
				}

				if(!empty($article->smalldesc)){
					$result .= $acypluginsHelper->wrapText($article->smalldesc, $tag).'<br />';
				}elseif(!empty($article->filedesc)){
					$result .= $acypluginsHelper->wrapText($article->filedesc, $tag).'<br />';
				}

				$result .= '<table cellspacing="0" cellpadding="0" border="0" >';
				foreach($intro as $OneIntro){
					$result .= '<tr>'.$OneIntro.'</tr>';
				}
				$result .= '</table>';
			}else{
				$result .= '<div style="margin-bottom:10px;">';

				if(!empty($article->subtitle)){
					$result .= $article->subtitle.'<br /><br />';
				}
				if(!empty($article->smalldesc)){
					$result .= $article->smalldesc.'<br />';
				}
				if(!empty($article->filedesc)){
					$result .= $acypluginsHelper->wrapText($article->filedesc, $tag);
				}
				$result .= '</div><table cellspacing="0" cellpadding="0" border="0" >';
				foreach($full as $OneFull){
					$result .= '<tr>'.$OneFull.'</tr>';
				}
				$result .= '</table>';
			}
			$result = $resultTitle.$result.$download;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result.$download;
		}


		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'remository.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'remository.php');
			$result = ob_get_clean();
			$result = str_replace(array_keys($varFields), $varFields, $result);
		}

		$result = $acypluginsHelper->removeJS($result);

		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight', 150) : $tag->maxheight;
				$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth', 150) : $tag->maxwidth;
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif(acymailing_isAdmin()){
					acymailing_enqueueMessage($pictureHelper->error, 'notice');
				}
			}
		}

		return $result;
	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags), $this->tags, $email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags), $this->tags, $email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag, strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis', ' | ', $result)), $email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){
		$acypluginsHelper = acymailing_get('helper.acyplugins');

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();

		$tags = $acypluginsHelper->extractTags($email, 'autoremository');
		$this->tags = array();

		if(empty($tags)) return $return;

		foreach($tags as $oneTag => $parameter){
			if(isset($this->tags[$oneTag])){
				continue;
			}
			$allcats = explode('-', $parameter->id);
			//Load the articles based on all arguments...
			$selectedArea = array();
			foreach($allcats as $oneCat){
				if(empty($oneCat)) continue;
				$selectedArea[] = (int)$oneCat;
			}

			$query = 'SELECT id FROM #__downloads_files ';
			$where = array();
			if(!empty($selectedArea)){
				$where[] = '`containerid` IN ('.implode(',', $selectedArea).')';
			}

			if(!empty($parameter->filter) && !empty($email->params['lastgenerateddate'])){
				$datenow = JFactory::getDate($email->params['lastgenerateddate']);
				if(ACYMAILING_J30){
					$date = $datenow->format("%Y-%m-%d %H:%M:%S");
				}else{
					$date = $datenow->toFormat("%Y-%m-%d %H:%M:%S");
				}
				$condition = '`submitdate` >\''.$date.'\'';
				$where[] = $condition;
			}

			$where[] = "published = 1";

			if(!empty($parameter->featured)){
				$where[] = 'featured = 1';
			}

			if(!empty($parameter->nofeatured)){
				$where[] = 'featured <> 1';
			}


			$query .= ' WHERE ('.implode(') AND (', $where).')';
			if(!empty($parameter->order)){
				if($parameter->order == 'rand'){
					$query .= ' ORDER BY rand()';
				}else{
					$ordering = explode(',', $parameter->order);
					$query .= ' ORDER BY '.acymailing_secureField(trim($ordering[0])).' '.acymailing_secureField(trim($ordering[1]));
				}
			}

			if(!empty($parameter->max)){
				$query .= ' LIMIT '.(int)$parameter->max;
			}elseif(empty($email->params['lastgenerateddate'])){
				$query .= ' LIMIT 20';
			}

			$allArticles = acymailing_loadResultArray($query);

			if(!empty($parameter->min) && count($allArticles) < $parameter->min){
				//We won't generate the Newsletter
				$return->status = false;
				$return->message = 'Not enough Remository content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
			}

			$stringTag = '';
			if(!empty($allArticles)){
				if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autoremository.php')){
					ob_start();
					require(ACYMAILING_MEDIA.'plugins'.DS.'autoremository.php');
					$stringTag = ob_get_clean();
				}else{
					//we insert the article tag one after the other in a table as they are already sorted
					foreach($allArticles as $oneArticleId){
						$args = array();
						$args[] = 'remository:'.$oneArticleId;
						if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
						if(!empty($parameter->link)) $args[] = 'link';
						if(!empty($parameter->download)) $args[] = 'download';
						if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
						if(!empty($parameter->notitle)) $args[] = 'notitle';
						if(!empty($parameter->created)) $args[] = 'created';
						if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
						if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
						if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
						if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
						$arrayElements[] = '{'.implode('|', $args).'}';
					}
					$stringTag = $acypluginsHelper->getFormattedResult($arrayElements, $parameter);
				}
			}
			$this->tags[$oneTag] = $stringTag;
		}
		return $return;
	}

	function onAcyDisplayFilters(&$type){
		$groups = acymailing_loadObjectList("SELECT DISTINCT role FROM `#__assignments` GROUP BY role ");

		if(empty($groups)) return '';

		$type['remository_groups'] = 'Remository Groups';

		$groupsin = acymailing_get('type.operatorsin');
		$groupsin->js = 'onchange="countresults(__num__)"';
		$return = '<div id="filter__num__remository_groups">'.$groupsin->display("filter[__num__][remository_groups][type]");
		$return .= ' '.acymailing_select($groups, "filter[__num__][remository_groups][group]", 'class="inputbox" size="1" onchange="countresults(__num__)"', 'role', 'role').'</div>';

		return $return;
	}

	function onAcyProcessFilterCount_remository_groups(&$query, $filter, $num){
		$this->onAcyProcessFilter_remository_groups($query, $filter, $num);
		return acymailing_translation_sprintf('SELECTED_USERS', $query->count());
	}

	function onAcyProcessFilter_remository_groups(&$query, $filter, $num){
		//We get the e-mail of the users which belong to this group, it's much easier that way
		$allIds = acymailing_loadResultArray('SELECT access_id FROM `#__assignments` WHERE `role` = '.acymailing_escapeDB($filter['group']));
		if(empty($allIds)) $allIds = array('-1');
		$operator = ($filter['type'] == 'IN') ? 'IN' : "NOT IN";
		$query->where[] = 'sub.userid '.$operator.' ('.implode(',', $allIds).')';
	}

}//endclass